#include "cuda.h"
#include <cutil.h>
#include <time.h>
#include <cstdlib>
#include <cstdio>
#include <stdio.h>
#include <string.h>
#include "kernels.cu"

extern "C"
{
       void set_CUDA_constant_memoryarrayi_(const char* ch, int* iparams)// integer constant memory allocation*/
	 {
		cudaMemcpyToSymbol(ch,&iparams,sizeof(int),0,cudaMemcpyHostToDevice);
	 }

	void set_CUDA_constant_memoryarraya_(const char* ch, double* iparams,int numm) // integer constant memory allocation*/
	 {

	      cudaMemcpyToSymbol("a",&iparams,sizeof(double)*numm,0,cudaMemcpyHostToDevice); //CPU TO GPU  CONSTANT MEMORY COPY*/
	 }
	void set_CUDA_constant_memoryarrayb_(const char* ch, double* iparams,int numm) // integer constant memory allocation*/
	 {
	
	      cudaMemcpyToSymbol("b",&iparams,sizeof(double)*numm,0,cudaMemcpyHostToDevice); //CPU TO GPU  CONSTANT MEMORY COPY*/
	 }
	void set_CUDA_constant_memoryarrayt_(const char* ch, double iparams,int numm) // integer constant memory allocation*/
	 {
	
	      cudaMemcpyToSymbol("ti",&iparams,sizeof(double)*numm,0,cudaMemcpyHostToDevice); //CPU TO GPU  CONSTANT MEMORY COPY*/
	 }


	void CUcopyArrayFromDevicefloat_(vec_space* host,vec_space* device,int numComb)
	{
	    cudaMemcpy(host, device, numComb*sizeof(vec_space), cudaMemcpyDeviceToHost); // GPU TO CPU MEMORY COPY
		
	}

	void CUcopyArrayToDevicefloatS_(vec_space* device,vec_space* host, int numComb)
	{
	    cudaMemcpy(device, host, numComb*sizeof(vec_space),cudaMemcpyHostToDevice); // CPU TO GPU MEMORY COPY
		
	}
	void CUcopyArrayToDevicefloat_(double* device,double* host, int numComb)
	{
	    cudaMemcpy(device, host, numComb*sizeof(double),cudaMemcpyHostToDevice); // CPU TO GPU MEMORY COPY
		
	}

	void CUcopyArrayToDeviceint_(int* device,int* host, int numComb)
	{
	    cudaMemcpy(device, host, numComb*sizeof(int),cudaMemcpyHostToDevice); // CPU TO GPU MEMORY COPY
	}

	void CUallocaterealarraysS_(vec_space* arr[0], int numComb) //memory allocation on GPU
	{
	 
	    unsigned int memSize = sizeof(vec_space)*(numComb);
		printf("\n memsize vec sapce Mb %u \n",memSize/(1024*1024));
	    cudaMalloc((void**)(&arr[0]), memSize);	   
	}

	void CUallocaterealarraysBS_(BIGspace* arr[0], int numComb) //memory allocation on GPU
	{
	 
	    unsigned int memSize = sizeof(BIGspace)*(numComb);
	printf("\n memsize BIGspace Mb %u \n",memSize/(1024*1024));
	    cudaMalloc((void**)(&arr[0]), memSize);	   
	}

	void CUallocaterealarraysB_(Bspace* arr[0], int numComb) //memory allocation on GPU
	{
	 
	    unsigned int memSize = sizeof(Bspace)*(numComb);
	printf("\n memsize BSpace Mb %u \n",memSize/(1024*1024));
	    cudaMalloc((void**)(&arr[0]), memSize);	   
	}

	 void CUallocateintarrays_(int* arr[0], int numComb) //memory allocation on GPU for integer arrays
	{
	    unsigned int memSize = sizeof(arr[0])*(numComb);
	   (cudaMalloc((void**)&arr[0], memSize));
	   
	}

	 void intarrayss_(double* arr[0]) // FREE GPU MEMORY
	{
	    (cudaFree((int**)arr[0]));
	}

	 void CUdeleterealarraysBS_(BIGspace* arr) // FREE GPU MEMORY
	{
	   (cudaFree((void**)arr));
	}
	 void CUdeleterealarraysB_(Bspace* arr) // FREE GPU MEMORY
	{
	   (cudaFree((void**)arr));
	}
	void CUdeleterealarraysS_(vec_space* arr) // FREE GPU MEMORY
	{
	   (cudaFree((void**)arr));
	}

	 void CUError_(const char *msg) // ERROR CHECKER FOR CUDA
	{
		    cudaError_t err = cudaGetLastError();	    
		    if(cudaSuccess !=err)
		    {	    
		    printf("Darn..! CUDA ERROR : %s , %s \n",msg, cudaGetErrorString(err));
		    getchar();
		    }
	}


	void allocate_constants_gpu(double* ti,double* ode_b,double* ode_a) // called before the gpu_call function
	{
		 cudaSetDevice(1);
		//set_CUDA_constant_memoryarrayt_("ti",*ti,1);
		cudaMemcpyToSymbol("ti",ti,sizeof(double),0,cudaMemcpyHostToDevice);
		CUError_("PROBLEM WITH CONSTANT MEMORY ALLOCATION 'TI' ");

		cudaMemcpyToSymbol("b",ode_b,sizeof(double)*13,0,cudaMemcpyHostToDevice);//set_CUDA_constant_memoryarrayb_("b",ode_b,13);
		CUError_("PROBLEM WITH CONSTANT MEMORY ALLOCATION 'b' ");
		
		cudaMemcpyToSymbol("a",ode_a,sizeof(double)*156,0,cudaMemcpyHostToDevice);//set_CUDA_constant_memoryarraya_("a",ode_a,13*12);
		CUError_("PROBLEM WITH CONSTANT MEMORY ALLOCATION 'a' ");

		unsigned int mem= sizeof(int)*2+sizeof(double)*(13*12+1+13);
		printf("\n Total constant memory allocated = %0.9f (kb) \n",(double)mem/1024);
		//getchar();
		return;
		
	}
	
/* void DisplayProperties( cudaDeviceProp* pDeviceProp )  */
/* {  */
/*     if( !pDeviceProp )  */
/*         return;  */
/*   */
/*     printf( "\nDevice Name \t - %s ", pDeviceProp->name );  */
/*     printf( "\n**************************************");  */
/*     printf( "\nTotal Global Memory\t\t -%d KB", pDeviceProp->totalGlobalMem/1024 );  */
/*     printf( "\nShared memory available per block \t - %d KB", pDeviceProp->sharedMemPerBlock/1024 );  */
/*     printf( "\nNumber of registers per thread block \t - %d", pDeviceProp->regsPerBlock );  */
/*     printf( "\nWarp size in threads \t - %d", pDeviceProp->warpSize );  */
/*     printf( "\nMemory Pitch \t - %d bytes", pDeviceProp->memPitch );  */
/*     printf( "\nMaximum threads per block \t - %d", pDeviceProp->maxThreadsPerBlock );  */
/*     printf( "\nMaximum Thread Dimension (block) \t - %d %d %d", pDeviceProp->maxThreadsDim[0], pDeviceProp->maxThreadsDim[1], pDeviceProp->maxThreadsDim[2] );  */
/*     printf( "\nMaximum Thread Dimension (grid) \t - %d %d %d", pDeviceProp->maxGridSize[0], pDeviceProp->maxGridSize[1], pDeviceProp->maxGridSize[2] );  */
/*     printf( "\nTotal constant memory \t - %d bytes", pDeviceProp->totalConstMem );  */
/*     printf( "\nCUDA ver \t - %d.%d", pDeviceProp->major, pDeviceProp->minor );  */
/*     printf( "\nClock rate \t - %d KHz", pDeviceProp->clockRate );  */
/*     printf( "\nTexture Alignment \t - %d bytes", pDeviceProp->textureAlignment );  */
/*     printf( "\nDevice Overlap \t - %s", pDeviceProp-> deviceOverlap?"Allowed":"Not Allowed" );  */
/*     printf( "\nNumber of Multi processors \t - %d", pDeviceProp->multiProcessorCount );  */
/* }  */
/*  */


void CALL_gpu(double* cpu_space,int* space_len,int* space_dim)
	{

	  cudaSetDevice(1);


    int deviceCount;		
	CUDA_SAFE_CALL(cudaGetDeviceCount(&deviceCount));
    printf(" NO OF DEVICES %d \n", deviceCount);
    
   printf("Running on......\n");

        cudaDeviceProp deviceProp;
        cudaGetDeviceProperties(&deviceProp, 1);
        printf ("      device %d:%s\n", 1,deviceProp.name);
  

	int SpaceSize = *space_len;
	int SpaceDim  = *space_dim;	
	BIGspace* ff;
	vec_space* gpu_space;
	Bspace* tempvar;
	Bspace* ypass;


	cudaEvent_t start,stop;
	
	cudaEventCreate(&start);
	cudaEventCreate(&stop);
   cudaEventRecord(start,0);
   
	CUallocaterealarraysS_(&gpu_space,1);
	CUError_("PROBLEM MEMORY ALLOCATION 1 ");

	CUallocaterealarraysBS_(&ff,546);
	CUError_("PROBLEM MEMORY ALLOCATION 2 ");	

	CUallocaterealarraysB_(&tempvar,42);
	CUError_("PROBLEM MEMORY ALLOCATION 3 ");

	CUallocaterealarraysB_(&ypass,42);
	CUError_("PROBLEM MEMORY ALLOCATION 4 ");

	cudaMemcpy(gpu_space,cpu_space,sizeof(vec_space),cudaMemcpyHostToDevice); 

	cudaEventRecord(stop,0);	
	cudaEventSynchronize(stop);
	
	float elapseTime;
	cudaEventElapsedTime(&elapseTime,start,stop);
	
	printf("\n time taken by malloc+MemCOPY (sec) %.9f\n",(double)elapseTime/1000.0);
			
	dim3 dimBlock(Block_size);
	dim3 dimGrid((int)SpaceSize/Block_size);
	dim3 dimGrid2((int)SpaceSize/Block_size2);
	dim3 dimGrid3((int)SpaceSize/Block_size3);
	
	if( SpaceSize % Block_size != 0 ) dimGrid.x+=1;
	printf("\n number of thread blocks  = %d \n", dimGrid.x);
	printf("\n number of threads/blocks = %d \n", dimBlock.x);

	dim3 dimBlock2(Block_size2);
   printf("\n number of thread blocks 2 = %d \n", dimGrid2.x);
	printf("\n number of threads/blocks 2 = %d \n", dimBlock2.x);

//-------------------KERNEL CALLS--------------------------------//

	cudaEventRecord(start,0);
	
	gpu_ford_phia<<<dimGrid,dimBlock>>>(gpu_space,ff,tempvar);		
	for(int i=0;i<12;i++)
	{	
	gpu_ford_phib<<<dimGrid,dimBlock>>>(gpu_space,ff,ypass,tempvar,i);	
	gpu_ford_phic<<<dimGrid2,dimBlock2>>>(gpu_space,ff,ypass,tempvar,i);	  
	}
	
//---------------------------------------------------//

	
	cudaEventRecord(stop,0);	
	cudaEventSynchronize(stop);
	float elapsedTime;
	cudaEventElapsedTime(&elapsedTime,start,stop);
	
	printf("\n time taken by kernel (sec) %.9f , %.9f\n",(double)elapsedTime/1000.0);
	
	Bspace* cpuphi=(Bspace*)malloc(42*sizeof(Bspace));

	cudaMemcpy(cpuphi,ypass,42*sizeof(Bspace), cudaMemcpyDeviceToHost);
	
	for(int i = 6;i<42;i++){
	    printf("\n index %d, val %.15f \n",i ,cpuphi[i].x[0] );
	    getchar();
	    }
	    
	    
	CUdeleterealarraysS_(gpu_space);
	CUdeleterealarraysB_(tempvar);
	CUdeleterealarraysB_(ypass);
	CUdeleterealarraysBS_(ff);
	
	cudaEventDestroy(start);
	cudaEventDestroy(stop);
	 
   
     


	}
}
	

