#define Block_size2 320 // number of threads per block
#define N 30720
#define Block_size 320
//#define Block_size3 2//320

#include <math.h>

	__constant__ double b[13];
	__constant__ double a[156];
	__constant__ double ti;


	typedef struct __align__(128) hu{		
		double x[N];
		double y[N];
		double z[N];
		double u[N];
		double v[N];
		double w[N];
		double h[N];
		}vec_space;

	typedef struct __align__(8) h{		
		double x[N];
		}BIGspace;

	typedef struct __align__(8) he{		
		double x[N];
		}Bspace;

__shared__ double Z[Block_size];
__shared__ double X[Block_size];
__shared__ double Y[Block_size];
__shared__ double sh[3][Block_size2];

__device__ void compute_fx(double *fxI,int indx) //40 flops
	{
			// checked for floating point cosistency.. GOSH TOOK 4 HRS. GOD KERNEL cat !!!

			volatile double temp3 = X[indx]*X[indx];
			volatile double rsq  = sqrt(temp3  + Y[indx]*Y[indx] + Z[indx]*Z[indx]);			
			// forming the diognal elements	
			double mull = rsq*rsq;	
			fxI[0] = 3.0*temp3-mull;			
			temp3 = Y[indx]*Y[indx];
			fxI[4] = 3.0*temp3 -mull;						
			temp3 = Z[indx]*Z[indx];	
			fxI[8] = 3.0*temp3-mull;
			temp3 = rsq*rsq*rsq;
			rsq = temp3*rsq*rsq;
			temp3 = 1.0/temp3;
			fxI[3] = -X[indx]*temp3;
			fxI[6] = -Y[indx]*temp3;
			fxI[7] = -Z[indx]*temp3;
			temp3 = 1.0/rsq;
			fxI[0] = fxI[0]*temp3;
			fxI[4] = fxI[4]*temp3;
			fxI[8] = fxI[8]*temp3;				
			fxI[1] =  (3.0*(X[indx]*Y[indx]))*temp3;
			fxI[2] =  (3.0*(X[indx]*Z[indx]))*temp3;
			fxI[5] =  (3.0*(Y[indx]*Z[indx]))*temp3;	
		
			return;			
	
	}
//	
//
 __device__  void getphi(BIGspace* phi,int ind,int stride,int indx){

	double fx[9]; 
		 // 12 more registers , total = 51
		compute_fx(fx,ind);		
		
		//updating derivatives of state for integration		
		phi[3+stride].x[indx] = fx[3];
		phi[4+stride].x[indx] = fx[6];
		phi[5+stride].x[indx] = fx[7];
	

		for(int i = 6;i<42;i++)
		 {	
			phi[i+stride].x[indx] = 0.0; // all zeros except first 5
		}
			
				// used symmetry		
		phi[24+stride].x[indx] = fx[0];
		phi[25+stride].x[indx] = fx[1];	
		phi[26+stride].x[indx] = fx[2];	
		phi[30+stride].x[indx] = fx[1];	
		phi[31+stride].x[indx] = fx[4];			
		phi[32+stride].x[indx] = fx[5];		
		phi[36+stride].x[indx] = fx[2];	
		phi[37+stride].x[indx] = fx[5];			
		phi[38+stride].x[indx] = fx[8];
		phi[9 +stride].x[indx] = 1.0;
		phi[16+stride].x[indx] = 1.0;
		phi[23+stride].x[indx] = 1.0;		


}

 __global__ void gpu_ford_phia(vec_space* gpu_space,BIGspace* ff,Bspace* temp2)// 2 registers
{
	unsigned int indx = __umul24(blockIdx.x,blockDim.x)+threadIdx.x; // 1 register

	 X[threadIdx.x]  = gpu_space->x[indx];
	 Y[threadIdx.x]  = gpu_space->y[indx];
	 Z[threadIdx.x]  = gpu_space->z[indx];		

		getphi(ff,threadIdx.x,0,indx); // ff 546 (13*42) long double long vector conitns the derivative info ...//
	
	ff[0].x[indx] = gpu_space->u[indx];
	ff[1].x[indx] = gpu_space->v[indx];
	ff[2].x[indx] = gpu_space->w[indx];	
	for(int i = 0; i<42;i++ )	// intalize temp2 42 values for each thread to zero
				temp2[i].x[indx] = 0.0;
				
			//	printf("\n thread number %d \n",indx);
				
}

 __global__ void gpu_ford_phib(vec_space* gpu_space,BIGspace* ff,Bspace* ypass,Bspace* temp2,volatile int m)// 2 registers
{
	unsigned int indx = __umul24(blockIdx.x,blockDim.x)+threadIdx.x; // 1 register
	int ind = threadIdx.x;

	 X[ind]  = gpu_space->x[indx];
	 Y[ind]  = gpu_space->y[indx];
	 Z[ind]  = gpu_space->z[indx];
	 double u = gpu_space->u[indx];
	 double v = gpu_space->v[indx];
	 double w = gpu_space->w[indx];
	 double h = gpu_space->h[indx];
//	printf("\n 6 - SPACE %f,%f,%f,%f,%f,%f , %d \n", X[ind], Y[ind], Z[ind],u,v,w , m);
	volatile int i,j,k;        
	double doty;	
	double cpy;
	double cpy2;
	volatile int nex=__umul24((m+1),42); 

	// next two loops compute matirx vector dot products (temp2 is common over the 12 outer kernel loops)	 
	 k = m*13;
			for(i = 0; i<42;i++ )	// 7 blocks 6 wide 
				{		
				
				if(m>0&&i>23)ff[i +__umul24(42,m)].x[indx] = ypass[i].x[indx];	
				
				cpy2 = 0.0;	
				for (j=0;j<m+1;j++)
					{				
					   cpy   = ff[i +__umul24(42,j)].x[indx];// tempv[i];					
					   if(j==m)
	   				doty  = cpy*b[j]; // minor dot product a and b are in constant memory					
	   				
   					cpy2 += cpy*a[j+k];//USe cache locality--main dot pod				
					}
													
					temp2[i].x[indx]  +=   doty;
								
					if(i<6)
					{					
					switch(i)
					   {					 
						case 0: X[ind]  += h*cpy2;break;
						case 1: Y[ind]  += h*cpy2;break;
						case 2: Z[ind]  += h*cpy2;break;
						case 3: u       += h*cpy2;break;
						case 4: v       += h*cpy2;break;
						case 5: w       += h*cpy2;break;
						 }
					}
				else {
				switch(i)
					{
					case 6:  ypass[i].x[indx] = 1.0 + h*cpy2;break;
					case 13: ypass[i].x[indx] = 1.0 + h*cpy2;break;			
					case 20: ypass[i].x[indx] = 1.0 + h*cpy2;break;
					case 27: ypass[i].x[indx] = 1.0 + h*cpy2;break;
					case 34: ypass[i].x[indx] = 1.0 + h*cpy2;break;
					case 41:ypass[i].x[indx]  = 1.0 + h*cpy2;break;
					default:ypass[i].x[indx]  = h*cpy2;break;
					}              
               }
				}
				// printf("\n updated u %.11f \n",u);
   __syncthreads;

	getphi(ff,ind,nex,indx);
	
	ff[0+nex].x[indx] = u;
	ff[1+nex].x[indx] = v;
	ff[2+nex].x[indx] = w;
	

	
}



 __global__ void gpu_ford_phic(vec_space* gpu_space,BIGspace* ff,Bspace* ypass,Bspace* temp2,volatile int m)// 2 registers
{ 
// 6 by 6 per thread matrix matrix multiply..

	unsigned int indx = __umul24(blockIdx.x,blockDim.x)+threadIdx.x; // 1 register
	double h = gpu_space->h[indx];
   int ind = threadIdx.x;
	volatile int i,j,k,mul;	
	double a;
	volatile int nex = __umul24(m+1,42) + 6;

//	printf("\n nex %d \n",nex);

	k =24;	
	mul = nex+6;	
	for(j=0;j<6;j++)	{
	ff[nex+ j].x[indx]= ypass[k+j].x[indx];
	ff[mul+ j].x[indx]= ypass[30+j].x[indx];
	ff[mul+6+ j].x[indx]= ypass[36+j].x[indx];
	}

/*	*/
		for (j=0; j<6; j++)
		{		
		   
		   for(i=0;i<3;i++){
		   k = __umul24(6,i)+j+6;
		   sh[i][ind] = ypass[k].x[indx];				
		      }
		   __syncthreads;
	      for (i=3; i<6; i++)
	      {
	         a = 0.0;	       
	         mul = nex + __umul24(6,i);	       
	         for(k=0;k<3;k++)
	         a += ff[k+mul].x[indx]*sh[k][ind];
	         
	         ypass[__umul24(6,i)+j+6].x[indx] = a;
	        
	     }	     
	   
	  }
	  
	if(m==11){  
	for(i = 6 ; i<42 ; i++) {
	         if(i<24){
				a = ff[i+12*42].x[indx]*b[12];//				
				}
				else{
				a = ypass[i].x[indx]*b[12];
				}
				
				a = h*(temp2[i].x[indx] + a);//
							
				switch(i)
					{
					case 6:  a += 1.0;break;
					case 13: a += 1.0;break;		
					case 20: a += 1.0;break;
					case 27: a += 1.0;break;
					case 34: a += 1.0;break;
					case 41: a += 1.0;break;
					}
				ypass[i].x[indx] = a;		  
			  
			}
	 }      
	      	
}      

